# -*- coding: utf-8 -*-
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

from libc.stdint cimport *
from libc.string cimport *

from ..crc32c_c import Crc32c

cdef class Checksum:

    cdef object crc

    cpdef update_bool(self, bint val)

    cpdef update_int(self, int32_t val)

    cpdef update_long(self, int64_t val)

    cpdef update_float(self, double val)

    cpdef update(self, bytes b)

    cpdef uint32_t getvalue(self)

    cpdef reset(self)